<html>
<head>
<title>OgreWorkQueue.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreWorkQueue.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreWorkQueue_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __OgreWorkQueue_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __OgreWorkQueue_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreAtomicWrappers_8h.html">OgreAtomicWrappers.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreAny_8h.html">OgreAny.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreSharedPtr_8h.html">OgreSharedPtr.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre
<a name="l00037"></a>00037 {
<a name="l00069"></a><a class="code" href="classOgre_1_1WorkQueue.html">00069</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1WorkQueue.html" title="Interface to a general purpose request / response style background work queue.">WorkQueue</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">UtilityAlloc</a>
<a name="l00070"></a>00070     {
<a name="l00071"></a>00071     <span class="keyword">protected</span>:
<a name="l00072"></a><a class="code" href="classOgre_1_1WorkQueue.html#a49e33316b1140dca7d9aa81e5b47d49b">00072</a>         <span class="keyword">typedef</span> std::map&lt;String, uint16&gt; <a class="code" href="classOgre_1_1WorkQueue.html#a49e33316b1140dca7d9aa81e5b47d49b">ChannelMap</a>;
<a name="l00073"></a><a class="code" href="classOgre_1_1WorkQueue.html#a4e043b97536f11e70189d8184fbaa7f8">00073</a>         <a class="code" href="classOgre_1_1WorkQueue.html#a49e33316b1140dca7d9aa81e5b47d49b">ChannelMap</a> <a class="code" href="classOgre_1_1WorkQueue.html#a4e043b97536f11e70189d8184fbaa7f8">mChannelMap</a>;
<a name="l00074"></a><a class="code" href="classOgre_1_1WorkQueue.html#ad2ff94d54fe961e1e59558f361093b65">00074</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1WorkQueue.html#ad2ff94d54fe961e1e59558f361093b65">mNextChannel</a>;
<a name="l00075"></a>00075         <a class="code" href="OgrePrerequisites_8h.html#a2fb96ea8ad9700f804480d1d7f5d692d">OGRE_MUTEX</a>(mChannelMapMutex)
<a name="l00076"></a>00076     public:
<a name="l00078"></a><a class="code" href="classOgre_1_1WorkQueue.html#a1908257e726af6caa80f1a6cd5682d76">00078</a>         typedef <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1WorkQueue.html#a1908257e726af6caa80f1a6cd5682d76" title="Numeric identifier for a request.">RequestID</a>;
<a name="l00079"></a>00079 
<a name="l00082"></a><a class="code" href="classOgre_1_1WorkQueue_1_1Request.html">00082</a>         class <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html" title="General purpose request structure.">Request</a> : public <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">UtilityAlloc</a>
<a name="l00083"></a>00083         {
<a name="l00084"></a><a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#afc5a5e65333384e477426c2f77353b28">00084</a>             <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1WorkQueue.html" title="Interface to a general purpose request / response style background work queue.">WorkQueue</a>;
<a name="l00085"></a>00085         <span class="keyword">protected</span>:
<a name="l00087"></a><a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#acb3929d1fa36c620de9db9b5de660937">00087</a>             <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#acb3929d1fa36c620de9db9b5de660937" title="The request channel, as an integer.">mChannel</a>;
<a name="l00089"></a><a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a590a4da4cee5711be64e525e0564cf72">00089</a>             <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a590a4da4cee5711be64e525e0564cf72" title="The request type, as an integer within the channel (user can define enumerations on this)...">mType</a>;
<a name="l00091"></a><a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#ad8d1f9709048464bd8445d5466c7451f">00091</a>             <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#ad8d1f9709048464bd8445d5466c7451f" title="The details of the request (user defined)">mData</a>;
<a name="l00093"></a><a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#ad3731e8a478ae2f522288c0366513352">00093</a>             <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#ad3731e8a478ae2f522288c0366513352" title="Retry count - set this to non-zero to have the request try again on failure.">mRetryCount</a>;
<a name="l00095"></a><a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a5d54982d3c93db2df770394469f776c4">00095</a>             RequestID <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a5d54982d3c93db2df770394469f776c4" title="Identifier (assigned by the system)">mID</a>;
<a name="l00097"></a><a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#ab71d4e2b421f8f1920a7e4ca4f43ee73">00097</a>             <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#ab71d4e2b421f8f1920a7e4ca4f43ee73" title="Abort Flag.">mAborted</a>;
<a name="l00098"></a>00098 
<a name="l00099"></a>00099         <span class="keyword">public</span>:
<a name="l00101"></a>00101             <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html" title="General purpose request structure.">Request</a>(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> rtype, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; rData, <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> retry, RequestID rid);
<a name="l00102"></a>00102             ~<a class="code" href="classOgre_1_1WorkQueue_1_1Request.html" title="General purpose request structure.">Request</a>();
<a name="l00104"></a><a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a2c9eb47c5193369a6c273455453d3a3c">00104</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a2c9eb47c5193369a6c273455453d3a3c" title="Set the abort flag.">abortRequest</a>()<span class="keyword"> const </span>{ mAborted = <span class="keyword">true</span>; }
<a name="l00106"></a><a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#aab05288e180b61054443991cb8c2fd68">00106</a>             <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#aab05288e180b61054443991cb8c2fd68" title="Get the request channel (top level categorisation)">getChannel</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mChannel; }
<a name="l00108"></a><a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a69a54c0507b6686e3c48a21283477ac0">00108</a>             <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a69a54c0507b6686e3c48a21283477ac0" title="Get the type of this request within the given channel.">getType</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mType; }
<a name="l00110"></a><a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a97cba781f6894fabd2c23dfd12f344ba">00110</a>             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a97cba781f6894fabd2c23dfd12f344ba" title="Get the user details of this request.">getData</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mData; }
<a name="l00112"></a><a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a17eba593da5a1051976053e3599ec7c9">00112</a>             <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a17eba593da5a1051976053e3599ec7c9" title="Get the remaining retry count.">getRetryCount</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mRetryCount; }
<a name="l00114"></a><a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a2787c787efe6db76de47fa52e53ec4ec">00114</a>             RequestID <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a2787c787efe6db76de47fa52e53ec4ec" title="Get the identifier of this request.">getID</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mID; }
<a name="l00116"></a><a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a9edf6b9791e2b39df101a288e1289bb6">00116</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a9edf6b9791e2b39df101a288e1289bb6" title="Get the abort flag.">getAborted</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mAborted; }
<a name="l00117"></a>00117         };
<a name="l00118"></a>00118 
<a name="l00121"></a><a class="code" href="structOgre_1_1WorkQueue_1_1Response.html">00121</a>         <span class="keyword">struct </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">Response</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">UtilityAlloc</a>
<a name="l00122"></a>00122         {
<a name="l00124"></a><a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#afdbe309b03faf1265f97d4891af4d258">00124</a>             <span class="keyword">const</span> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html" title="General purpose request structure.">Request</a>* <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#afdbe309b03faf1265f97d4891af4d258" title="Pointer to the request that this response is in relation to.">mRequest</a>;
<a name="l00126"></a><a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#abe22e0d3b55dc09fe6ba3e592f7dc321">00126</a>             <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#abe22e0d3b55dc09fe6ba3e592f7dc321" title="Whether the work item succeeded or not.">mSuccess</a>;
<a name="l00128"></a><a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#aa79894f8c3badaddc48064f4b35141be">00128</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#aa79894f8c3badaddc48064f4b35141be" title="Any diagnostic messages.">mMessages</a>;
<a name="l00130"></a><a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#a04980c518c8e22f1f669e6b543a10e20">00130</a>             <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#a04980c518c8e22f1f669e6b543a10e20" title="Data associated with the result of the process.">mData</a>;
<a name="l00131"></a>00131 
<a name="l00132"></a>00132         <span class="keyword">public</span>:
<a name="l00133"></a>00133             <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">Response</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html" title="General purpose request structure.">Request</a>* rq, <span class="keywordtype">bool</span> success, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; data, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; msg = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00134"></a>00134             ~<a class="code" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">Response</a>();
<a name="l00136"></a><a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#a5f4e4aca88b7c19172507621d367521a">00136</a>             <span class="keyword">const</span> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html" title="General purpose request structure.">Request</a>* <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#a5f4e4aca88b7c19172507621d367521a" title="Get the request that this is a response to (NB destruction destroys this)">getRequest</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mRequest; }
<a name="l00138"></a><a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#a64dc34a33331d3dd7537bf03eabf27ec">00138</a>             <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#a64dc34a33331d3dd7537bf03eabf27ec" title="Return whether this is a successful response.">succeeded</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSuccess; }
<a name="l00140"></a><a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#a4f02e67c20f209699ea6e9b8bbac9bfb">00140</a>             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#a4f02e67c20f209699ea6e9b8bbac9bfb" title="Get any diagnostic messages about the process.">getMessages</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMessages; }
<a name="l00142"></a><a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#a6a658b42012b9dceb78068ad68cc931e">00142</a>             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#a6a658b42012b9dceb78068ad68cc931e" title="Return the response data (user defined, only valid on success)">getData</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mData; }
<a name="l00144"></a><a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#a29ac9eeab02d77b028ec3a3dd8f7964c">00144</a>             <span class="keywordtype">void</span> <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#a29ac9eeab02d77b028ec3a3dd8f7964c" title="Abort the request.">abortRequest</a>() { mRequest-&gt;abortRequest(); mData.destroy(); }
<a name="l00145"></a>00145         };
<a name="l00146"></a>00146 
<a name="l00160"></a><a class="code" href="classOgre_1_1WorkQueue_1_1RequestHandler.html">00160</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1WorkQueue_1_1RequestHandler.html" title="Interface definition for a handler of requests.">RequestHandler</a>
<a name="l00161"></a>00161         {
<a name="l00162"></a>00162         <span class="keyword">public</span>:
<a name="l00163"></a><a class="code" href="classOgre_1_1WorkQueue_1_1RequestHandler.html#a37f35aaa5935b91a180d92e5243fccb7">00163</a>             <a class="code" href="classOgre_1_1WorkQueue_1_1RequestHandler.html#a37f35aaa5935b91a180d92e5243fccb7">RequestHandler</a>() {}
<a name="l00164"></a><a class="code" href="classOgre_1_1WorkQueue_1_1RequestHandler.html#a0d7c8fced3825d323b12b5dbd167bf83">00164</a>             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1WorkQueue_1_1RequestHandler.html#a0d7c8fced3825d323b12b5dbd167bf83">~RequestHandler</a>() {}
<a name="l00165"></a>00165 
<a name="l00172"></a><a class="code" href="classOgre_1_1WorkQueue_1_1RequestHandler.html#adf4a5093c7b789352a0a44629490bc87">00172</a>             <span class="keyword">virtual</span> <span class="keywordtype">bool</span> canHandleRequest(<span class="keyword">const</span> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html" title="General purpose request structure.">Request</a>* req, <span class="keyword">const</span> <a class="code" href="classOgre_1_1WorkQueue.html" title="Interface to a general purpose request / response style background work queue.">WorkQueue</a>* srcQ) 
<a name="l00173"></a>00173             { (void)srcQ; <span class="keywordflow">return</span> !req-&gt;<a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a9edf6b9791e2b39df101a288e1289bb6" title="Get the abort flag.">getAborted</a>(); }
<a name="l00174"></a>00174 
<a name="l00185"></a>00185             <span class="keyword">virtual</span> <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">Response</a>* handleRequest(<span class="keyword">const</span> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html" title="General purpose request structure.">Request</a>* req, <span class="keyword">const</span> <a class="code" href="classOgre_1_1WorkQueue.html" title="Interface to a general purpose request / response style background work queue.">WorkQueue</a>* srcQ) = 0;
<a name="l00186"></a>00186         };
<a name="l00187"></a>00187 
<a name="l00195"></a><a class="code" href="classOgre_1_1WorkQueue_1_1ResponseHandler.html">00195</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1WorkQueue_1_1ResponseHandler.html" title="Interface definition for a handler of responses.">ResponseHandler</a>
<a name="l00196"></a>00196         {
<a name="l00197"></a>00197         <span class="keyword">public</span>:
<a name="l00198"></a><a class="code" href="classOgre_1_1WorkQueue_1_1ResponseHandler.html#a0e4215e93030a19595bc2d2e30f0a938">00198</a>             <a class="code" href="classOgre_1_1WorkQueue_1_1ResponseHandler.html#a0e4215e93030a19595bc2d2e30f0a938">ResponseHandler</a>() {}
<a name="l00199"></a><a class="code" href="classOgre_1_1WorkQueue_1_1ResponseHandler.html#a5fb201476bd4bf5a14425c4598753aab">00199</a>             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1WorkQueue_1_1ResponseHandler.html#a5fb201476bd4bf5a14425c4598753aab">~ResponseHandler</a>() {}
<a name="l00200"></a>00200 
<a name="l00207"></a><a class="code" href="classOgre_1_1WorkQueue_1_1ResponseHandler.html#a7a2fabae7f92bed384f100526055a899">00207</a>             <span class="keyword">virtual</span> <span class="keywordtype">bool</span> canHandleResponse(<span class="keyword">const</span> <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">Response</a>* res, <span class="keyword">const</span> <a class="code" href="classOgre_1_1WorkQueue.html" title="Interface to a general purpose request / response style background work queue.">WorkQueue</a>* srcQ) 
<a name="l00208"></a>00208             { (void)srcQ; <span class="keywordflow">return</span> !res-&gt;<a class="code" href="structOgre_1_1WorkQueue_1_1Response.html#a5f4e4aca88b7c19172507621d367521a" title="Get the request that this is a response to (NB destruction destroys this)">getRequest</a>()-&gt;<a class="code" href="classOgre_1_1WorkQueue_1_1Request.html#a9edf6b9791e2b39df101a288e1289bb6" title="Get the abort flag.">getAborted</a>(); }
<a name="l00209"></a>00209 
<a name="l00217"></a>00217             <span class="keyword">virtual</span> <span class="keywordtype">void</span> handleResponse(<span class="keyword">const</span> <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">Response</a>* res, <span class="keyword">const</span> <a class="code" href="classOgre_1_1WorkQueue.html" title="Interface to a general purpose request / response style background work queue.">WorkQueue</a>* srcQ) = 0;
<a name="l00218"></a>00218         };
<a name="l00219"></a>00219 
<a name="l00220"></a><a class="code" href="classOgre_1_1WorkQueue.html#a522d959bdec37026c5ad9eb2e2b189cc">00220</a>         <a class="code" href="classOgre_1_1WorkQueue.html#a522d959bdec37026c5ad9eb2e2b189cc">WorkQueue</a>() : mNextChannel(0) {}
<a name="l00221"></a><a class="code" href="classOgre_1_1WorkQueue.html#a2e7a64f2d114bf2828355e83e43f8172">00221</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1WorkQueue.html#a2e7a64f2d114bf2828355e83e43f8172">~WorkQueue</a>() {}
<a name="l00222"></a>00222 
<a name="l00227"></a>00227         <span class="keyword">virtual</span> <span class="keywordtype">void</span> startup(<span class="keywordtype">bool</span> forceRestart = <span class="keyword">true</span>) = 0;
<a name="l00237"></a>00237         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addRequestHandler(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel, RequestHandler* rh) = 0;
<a name="l00239"></a>00239         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeRequestHandler(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel, RequestHandler* rh) = 0;
<a name="l00240"></a>00240 
<a name="l00250"></a>00250         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addResponseHandler(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel, ResponseHandler* rh) = 0;
<a name="l00252"></a>00252         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeResponseHandler(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel, ResponseHandler* rh) = 0;
<a name="l00253"></a>00253 
<a name="l00266"></a>00266         <span class="keyword">virtual</span> RequestID addRequest(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> requestType, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; rData, <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> retryCount = 0, 
<a name="l00267"></a>00267             <span class="keywordtype">bool</span> forceSynchronous = <span class="keyword">false</span>) = 0;
<a name="l00268"></a>00268 
<a name="l00274"></a>00274         <span class="keyword">virtual</span> <span class="keywordtype">void</span> abortRequest(RequestID <span class="keywordtype">id</span>) = 0;
<a name="l00275"></a>00275 
<a name="l00281"></a>00281         <span class="keyword">virtual</span> <span class="keywordtype">void</span> abortRequestsByChannel(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel) = 0;
<a name="l00282"></a>00282 
<a name="l00287"></a>00287         <span class="keyword">virtual</span> <span class="keywordtype">void</span> abortAllRequests() = 0;
<a name="l00288"></a>00288         
<a name="l00294"></a>00294         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setPaused(<span class="keywordtype">bool</span> pause) = 0;
<a name="l00296"></a>00296         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isPaused() <span class="keyword">const</span> = 0;
<a name="l00297"></a>00297 
<a name="l00302"></a>00302         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setRequestsAccepted(<span class="keywordtype">bool</span> accept) = 0;
<a name="l00304"></a>00304         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getRequestsAccepted() <span class="keyword">const</span> = 0;
<a name="l00305"></a>00305 
<a name="l00314"></a>00314         <span class="keyword">virtual</span> <span class="keywordtype">void</span> processResponses() = 0; 
<a name="l00315"></a>00315 
<a name="l00319"></a>00319         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> getResponseProcessingTimeLimit() <span class="keyword">const</span> = 0;
<a name="l00320"></a>00320 
<a name="l00326"></a>00326         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setResponseProcessingTimeLimit(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> ms) = 0;
<a name="l00327"></a>00327 
<a name="l00330"></a>00330         <span class="keyword">virtual</span> <span class="keywordtype">void</span> shutdown() = 0;
<a name="l00331"></a>00331 
<a name="l00339"></a>00339         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> getChannel(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; channelName);
<a name="l00340"></a>00340 
<a name="l00341"></a>00341     };
<a name="l00342"></a>00342 
<a name="l00345"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html">00345</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html" title="Base for a general purpose request / response style background work queue.">DefaultWorkQueueBase</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1WorkQueue.html" title="Interface to a general purpose request / response style background work queue.">WorkQueue</a>
<a name="l00346"></a>00346     {
<a name="l00347"></a>00347     <span class="keyword">public</span>:
<a name="l00348"></a>00348 
<a name="l00353"></a>00353         <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html" title="Base for a general purpose request / response style background work queue.">DefaultWorkQueueBase</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name = <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">StringUtil::BLANK</a>);
<a name="l00354"></a>00354         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1DefaultWorkQueueBase.html" title="Base for a general purpose request / response style background work queue.">DefaultWorkQueueBase</a>();
<a name="l00356"></a>00356         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName() <span class="keyword">const</span>;
<a name="l00360"></a>00360         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getWorkerThreadCount() <span class="keyword">const</span>;
<a name="l00361"></a>00361 
<a name="l00367"></a>00367         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setWorkerThreadCount(<span class="keywordtype">size_t</span> c);
<a name="l00368"></a>00368 
<a name="l00378"></a>00378         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getWorkersCanAccessRenderSystem() <span class="keyword">const</span>;
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 
<a name="l00392"></a>00392         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setWorkersCanAccessRenderSystem(<span class="keywordtype">bool</span> access);
<a name="l00393"></a>00393 
<a name="l00401"></a>00401         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _processNextRequest();
<a name="l00402"></a>00402 
<a name="l00404"></a>00404         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _threadMain() = 0;
<a name="l00405"></a>00405 
<a name="l00407"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a855d8e4410005c1c33fa1c399021667d">00407</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a855d8e4410005c1c33fa1c399021667d" title="Returns whether the queue is trying to shut down.">isShuttingDown</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mShuttingDown; }
<a name="l00408"></a>00408 
<a name="l00410"></a>00410         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addRequestHandler(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel, RequestHandler* rh);
<a name="l00412"></a>00412         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeRequestHandler(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel, RequestHandler* rh);
<a name="l00414"></a>00414         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addResponseHandler(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel, ResponseHandler* rh);
<a name="l00416"></a>00416         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeResponseHandler(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel, ResponseHandler* rh);
<a name="l00417"></a>00417 
<a name="l00419"></a>00419         <span class="keyword">virtual</span> RequestID addRequest(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> requestType, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; rData, <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> retryCount = 0, 
<a name="l00420"></a>00420             <span class="keywordtype">bool</span> forceSynchronous = <span class="keyword">false</span>);
<a name="l00422"></a>00422         <span class="keyword">virtual</span> <span class="keywordtype">void</span> abortRequest(RequestID <span class="keywordtype">id</span>);
<a name="l00424"></a>00424         <span class="keyword">virtual</span> <span class="keywordtype">void</span> abortRequestsByChannel(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel);
<a name="l00426"></a>00426         <span class="keyword">virtual</span> <span class="keywordtype">void</span> abortAllRequests();
<a name="l00428"></a>00428         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setPaused(<span class="keywordtype">bool</span> pause);
<a name="l00430"></a>00430         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isPaused() <span class="keyword">const</span>;
<a name="l00432"></a>00432         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setRequestsAccepted(<span class="keywordtype">bool</span> accept);
<a name="l00434"></a>00434         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getRequestsAccepted() <span class="keyword">const</span>;
<a name="l00436"></a>00436         <span class="keyword">virtual</span> <span class="keywordtype">void</span> processResponses(); 
<a name="l00438"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a415418e6732bed1a9ab760050fd37712">00438</a>         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a415418e6732bed1a9ab760050fd37712">getResponseProcessingTimeLimit</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mResposeTimeLimitMS; }
<a name="l00440"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a7b7a4119647b82187af2341d96f51e3b">00440</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a7b7a4119647b82187af2341d96f51e3b">setResponseProcessingTimeLimit</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> ms) { mResposeTimeLimitMS = ms; }
<a name="l00441"></a>00441     <span class="keyword">protected</span>:
<a name="l00442"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a5b04be635a457d43eba4308702783323">00442</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a5b04be635a457d43eba4308702783323">mName</a>;
<a name="l00443"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#acb6b9461db930de8fd0f1cd10a92fef7">00443</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#acb6b9461db930de8fd0f1cd10a92fef7">mWorkerThreadCount</a>;
<a name="l00444"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a9d869bc3efeccd2210c9eeb6e7b98c13">00444</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a9d869bc3efeccd2210c9eeb6e7b98c13">mWorkerRenderSystemAccess</a>;
<a name="l00445"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#af097c9e8aa35a894a3a1144b16e89c88">00445</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#af097c9e8aa35a894a3a1144b16e89c88">mIsRunning</a>;
<a name="l00446"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#ad855d24711ae89c19739e105b278ce13">00446</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#ad855d24711ae89c19739e105b278ce13">mResposeTimeLimitMS</a>;
<a name="l00447"></a>00447 
<a name="l00448"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a1332289260fd3c38bc31be1e7346346c">00448</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1deque.html">deque&lt;Request*&gt;::type</a> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a1332289260fd3c38bc31be1e7346346c">RequestQueue</a>;
<a name="l00449"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a2e79d9e50dba8e011013abe3373dfe96">00449</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1deque.html">deque&lt;Response*&gt;::type</a> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a2e79d9e50dba8e011013abe3373dfe96">ResponseQueue</a>;
<a name="l00450"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a6af06d193129b18b02967c2db64d06a8">00450</a>         <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a1332289260fd3c38bc31be1e7346346c">RequestQueue</a> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a6af06d193129b18b02967c2db64d06a8">mRequestQueue</a>;
<a name="l00451"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a4f03dc006c5e89c233dd0c06ae343f13">00451</a>         <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a1332289260fd3c38bc31be1e7346346c">RequestQueue</a> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a4f03dc006c5e89c233dd0c06ae343f13">mProcessQueue</a>;
<a name="l00452"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a08a0a4228b167ec236d5fbf63eefa11c">00452</a>         <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a2e79d9e50dba8e011013abe3373dfe96">ResponseQueue</a> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a08a0a4228b167ec236d5fbf63eefa11c">mResponseQueue</a>;
<a name="l00453"></a>00453 
<a name="l00455"></a><a class="code" href="structOgre_1_1DefaultWorkQueueBase_1_1OGRE__THREAD__WORKER__INHERIT.html">00455</a>         <span class="keyword">struct </span>WorkerFunc <a class="code" href="structOgre_1_1DefaultWorkQueueBase_1_1OGRE__THREAD__WORKER__INHERIT.html" title="Thread function.">OGRE_THREAD_WORKER_INHERIT</a>
<a name="l00456"></a>00456         {
<a name="l00457"></a><a class="code" href="structOgre_1_1DefaultWorkQueueBase_1_1OGRE__THREAD__WORKER__INHERIT.html#a76c32be63b9643d2a32e1c219a73c1bc">00457</a>             <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html" title="Base for a general purpose request / response style background work queue.">DefaultWorkQueueBase</a>* <a class="code" href="structOgre_1_1DefaultWorkQueueBase_1_1OGRE__THREAD__WORKER__INHERIT.html#a76c32be63b9643d2a32e1c219a73c1bc">mQueue</a>;
<a name="l00458"></a>00458 
<a name="l00459"></a><a class="code" href="structOgre_1_1DefaultWorkQueueBase_1_1OGRE__THREAD__WORKER__INHERIT.html#ac3eb4efc2bf56cf25eae4f2f28d44c5c">00459</a>             WorkerFunc(<a class="code" href="classOgre_1_1DefaultWorkQueueBase.html" title="Base for a general purpose request / response style background work queue.">DefaultWorkQueueBase</a>* q) 
<a name="l00460"></a>00460                 : mQueue(q) {}
<a name="l00461"></a>00461 
<a name="l00462"></a>00462             <span class="keywordtype">void</span> operator()();
<a name="l00463"></a>00463 
<a name="l00464"></a>00464             <span class="keywordtype">void</span> run();
<a name="l00465"></a>00465         };
<a name="l00466"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a1b541ce363355b29709065e4402c4cc3">00466</a>         WorkerFunc* <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a1b541ce363355b29709065e4402c4cc3">mWorkerFunc</a>;
<a name="l00467"></a>00467 
<a name="l00472"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase_1_1RequestHandlerHolder.html">00472</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1DefaultWorkQueueBase_1_1RequestHandlerHolder.html" title="Intermediate structure to hold a pointer to a request handler which provides insurance against the ha...">RequestHandlerHolder</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">UtilityAlloc</a>
<a name="l00473"></a>00473         {
<a name="l00474"></a>00474         <span class="keyword">protected</span>:
<a name="l00475"></a>00475             <a class="code" href="OgrePrerequisites_8h.html#afd886be58b0d9b415076b07abfcc50fc">OGRE_RW_MUTEX</a>(mRWMutex);
<a name="l00476"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase_1_1RequestHandlerHolder.html#a298d2b179943f0db597e2b6077f94724">00476</a>             RequestHandler* <a class="code" href="classOgre_1_1DefaultWorkQueueBase_1_1RequestHandlerHolder.html#a298d2b179943f0db597e2b6077f94724">mHandler</a>;
<a name="l00477"></a>00477         <span class="keyword">public</span>:
<a name="l00478"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase_1_1RequestHandlerHolder.html#afaa91759d6e5dc5ec313ffebfc57241c">00478</a>             <a class="code" href="classOgre_1_1DefaultWorkQueueBase_1_1RequestHandlerHolder.html" title="Intermediate structure to hold a pointer to a request handler which provides insurance against the ha...">RequestHandlerHolder</a>(RequestHandler* handler)
<a name="l00479"></a>00479                 : mHandler(handler) {}
<a name="l00480"></a>00480 
<a name="l00481"></a>00481             <span class="comment">// Disconnect the handler to allow it to be destroyed</span>
<a name="l00482"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase_1_1RequestHandlerHolder.html#af754fb08a428c3b03a906796796cf3ab">00482</a>             <span class="keywordtype">void</span> disconnectHandler()
<a name="l00483"></a>00483             {
<a name="l00484"></a>00484                 <span class="comment">// write lock - must wait for all requests to finish</span>
<a name="l00485"></a>00485                 <a class="code" href="OgrePrerequisites_8h.html#a0a38f532fc987f34e7ffa1d18b770fc9">OGRE_LOCK_RW_MUTEX_WRITE</a>(mRWMutex);
<a name="l00486"></a>00486                 mHandler = 0;
<a name="l00487"></a>00487             }
<a name="l00488"></a>00488 
<a name="l00492"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase_1_1RequestHandlerHolder.html#a5b0863b8997318d9df5fd04dd61d6229">00492</a>             RequestHandler* <a class="code" href="classOgre_1_1DefaultWorkQueueBase_1_1RequestHandlerHolder.html#a5b0863b8997318d9df5fd04dd61d6229" title="Get handler pointer - note, only use this for == comparison or similar, do not attempt to call it as ...">getHandler</a>() { <span class="keywordflow">return</span> mHandler; }
<a name="l00493"></a>00493 
<a name="l00497"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase_1_1RequestHandlerHolder.html#a860e3df6911db6ac4808680ffc23e991">00497</a>             <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">Response</a>* handleRequest(<span class="keyword">const</span> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html" title="General purpose request structure.">Request</a>* req, <span class="keyword">const</span> <a class="code" href="classOgre_1_1WorkQueue.html" title="Interface to a general purpose request / response style background work queue.">WorkQueue</a>* srcQ)
<a name="l00498"></a>00498             {
<a name="l00499"></a>00499                 <span class="comment">// Read mutex so that multiple requests can be processed by the</span>
<a name="l00500"></a>00500                 <span class="comment">// same handler in parallel if required</span>
<a name="l00501"></a>00501                 <a class="code" href="OgrePrerequisites_8h.html#a94e5c080fee840c4ee87132157cc3eda">OGRE_LOCK_RW_MUTEX_READ</a>(mRWMutex);
<a name="l00502"></a>00502                 <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">Response</a>* response = 0;
<a name="l00503"></a>00503                 <span class="keywordflow">if</span> (mHandler)
<a name="l00504"></a>00504                 {
<a name="l00505"></a>00505                     <span class="keywordflow">if</span> (mHandler-&gt;canHandleRequest(req, srcQ))
<a name="l00506"></a>00506                     {
<a name="l00507"></a>00507                         response = mHandler-&gt;handleRequest(req, srcQ);
<a name="l00508"></a>00508                     }
<a name="l00509"></a>00509                 }
<a name="l00510"></a>00510                 <span class="keywordflow">return</span> response;
<a name="l00511"></a>00511             }
<a name="l00512"></a>00512 
<a name="l00513"></a>00513         };
<a name="l00514"></a>00514         <span class="comment">// Hold these by shared pointer so they can be copied keeping same instance</span>
<a name="l00515"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a3c0e76f0b22dcfd18977998f572ff71c">00515</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;RequestHandlerHolder&gt;</a> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a3c0e76f0b22dcfd18977998f572ff71c">RequestHandlerHolderPtr</a>;
<a name="l00516"></a>00516 
<a name="l00517"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a8bb1fe1911740f08c88b227175a8f242">00517</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html#ac64759673476a6852c0a09e1acec2a8c">list&lt;RequestHandlerHolderPtr&gt;::type</a> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a8bb1fe1911740f08c88b227175a8f242">RequestHandlerList</a>;
<a name="l00518"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a833a1a0e5e773052dbd8bdcd3dcf9929">00518</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html#ac64759673476a6852c0a09e1acec2a8c">list&lt;ResponseHandler*&gt;::type</a> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a833a1a0e5e773052dbd8bdcd3dcf9929">ResponseHandlerList</a>;
<a name="l00519"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#ae8772337dbdd3d55276776a0af69fa64">00519</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;uint16, RequestHandlerList&gt;::type</a> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#ae8772337dbdd3d55276776a0af69fa64">RequestHandlerListByChannel</a>;
<a name="l00520"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a7ca18891b4c7ea5eafcb10da2dddb79b">00520</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;uint16, ResponseHandlerList&gt;::type</a> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a7ca18891b4c7ea5eafcb10da2dddb79b">ResponseHandlerListByChannel</a>;
<a name="l00521"></a>00521 
<a name="l00522"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#acf77730bbb20b79f60fbcb26906c165a">00522</a>         <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#ae8772337dbdd3d55276776a0af69fa64">RequestHandlerListByChannel</a> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#acf77730bbb20b79f60fbcb26906c165a">mRequestHandlers</a>;
<a name="l00523"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#abd6a1a72dd9fb47da33cf2e4b40c1736">00523</a>         <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a7ca18891b4c7ea5eafcb10da2dddb79b">ResponseHandlerListByChannel</a> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#abd6a1a72dd9fb47da33cf2e4b40c1736">mResponseHandlers</a>;
<a name="l00524"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a105accd5cd88eeab80dcf3bcaa93a756">00524</a>         RequestID <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a105accd5cd88eeab80dcf3bcaa93a756">mRequestCount</a>;
<a name="l00525"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a1d02ca6b211ea6e87de25e6003a6dcaf">00525</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#a1d02ca6b211ea6e87de25e6003a6dcaf">mPaused</a>;
<a name="l00526"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#aa291e06e7f5d7e167e4417c63d48a93f">00526</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#aa291e06e7f5d7e167e4417c63d48a93f">mAcceptRequests</a>;
<a name="l00527"></a><a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#aa8e42b3888b8f39e5393789ee9de2c45">00527</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1DefaultWorkQueueBase.html#aa8e42b3888b8f39e5393789ee9de2c45">mShuttingDown</a>;
<a name="l00528"></a>00528 
<a name="l00529"></a>00529         <a class="code" href="OgrePrerequisites_8h.html#a2fb96ea8ad9700f804480d1d7f5d692d">OGRE_MUTEX</a>(mRequestMutex)
<a name="l00530"></a>00530         OGRE_MUTEX(mProcessMutex)
<a name="l00531"></a>00531         OGRE_MUTEX(mResponseMutex)
<a name="l00532"></a>00532         OGRE_RW_MUTEX(mRequestHandlerMutex);
<a name="l00533"></a>00533 
<a name="l00534"></a>00534 
<a name="l00535"></a>00535         <span class="keywordtype">void</span> processRequestResponse(<a class="code" href="classOgre_1_1WorkQueue_1_1Request.html" title="General purpose request structure.">Request</a>* r, <span class="keywordtype">bool</span> synchronous);
<a name="l00536"></a>00536         <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">Response</a>* processRequest(<a class="code" href="classOgre_1_1WorkQueue_1_1Request.html" title="General purpose request structure.">Request</a>* r);
<a name="l00537"></a>00537         <span class="keywordtype">void</span> processResponse(<a class="code" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">Response</a>* r);
<a name="l00539"></a>00539         virtual <span class="keywordtype">void</span> notifyWorkers() = 0;
<a name="l00541"></a>00541         <span class="keywordtype">void</span> addRequestWithRID(RequestID rid, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> requestType, const <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; rData, <a class="code" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> retryCount);
<a name="l00542"></a>00542 
<a name="l00543"></a>00543     };
<a name="l00544"></a>00544 
<a name="l00545"></a>00545 
<a name="l00546"></a>00546 
<a name="l00547"></a>00547 
<a name="l00548"></a>00548 
<a name="l00552"></a>00552 }
<a name="l00553"></a>00553 
<a name="l00554"></a>00554 
<a name="l00555"></a>00555 <span class="preprocessor">#endif</span>
<a name="l00556"></a>00556 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:53
</p>
</body>
</html>
